/**
 * BEGIN CMVC
 * *************************************************************************
 *
 *   Workfile: WBISRVR/ws/code/migration.wbi.ics.hapi/Access_EJB/AccessEJBEJB/ejbModule/com/crossworlds/access/business/cwsession/CwSessionBean.java, wbi.migration.ics.hapi, WBI70.WBISRVR, of1016.04
 *   Last update: 07/11/13 20:31:34
 *   SCCS path, id: /family/botp/vc/10/7/2/7/s.88 1.7
 *
 * ************************************************************************
 * END CMVC
 * BEGIN COPYRIGHT
 * ************************************************************************
 * Licensed Materials - Property of IBM
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15 
 * 
 * Copyright IBM Corporation 2004, 2007. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * DESCRIPTION:
 *
 * Change History:
 *
 * Reason          Date        User id     Description
 * ----------------------------------------------------------------------------
 *
 * ***********************************************************************
 * END COPYRIGHT
 **/

package com.crossworlds.access.business.cwsession;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.ejb.CreateException;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import CxCommon.HAPILogger;

import com.ibm.websphere.bo.BOFactory;
import com.ibm.websphere.bo.BOXMLSerializer;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceBusinessException;
import com.ibm.websphere.sca.ServiceManager;
import commonj.sdo.DataObject;
import commonj.sdo.Type;

/**
 * Bean implementation class for Enterprise Bean: CwSession   
 *
 * <dt>
 * 
 * </dt>
 */
public class CwSessionBean implements javax.ejb.SessionBean
{
	public static final String COPYRIGHT = "Copyright IBM Corporation 2006, 2007."; //$NON-NLS-1$
	public static final String CLASSNAME = CwSessionBean.class.getName();
	private static Logger logger = Logger.getLogger(CLASSNAME);

	private javax.ejb.SessionContext mySessionCtx;
	public static final String DEFAULT_LOG_FILE_STRING = "default"; //$NON-NLS-1$
	public static final String JNDI_LOG_FILE_NAME_STRING = "java:comp/env/logFile"; //$NON-NLS-1$
	public static final String JNDI_TRACE_LEVEL_STRING = "java:comp/env/traceLevel"; //$NON-NLS-1$
	public static final String JNDI_IC_SERVER_LIST_STRING = "java:comp/env/ICServers"; //$NON-NLS-1$
	public static final String JNDI_ENV_STRING = "java:comp/env"; //$NON-NLS-1$
	public static final String JNDI_IOR_LOCATION_STRING = "iorLocation"; //$NON-NLS-1$
	public static final String JNDI_USER_NAME_STRING = "userName"; //$NON-NLS-1$
	public static final String JNDI_PASSWORD_STRING = "passWord"; //$NON-NLS-1$
	public static final String JNDI_NUMACCESSSESSIONS_STRING = "numAccessSessions"; //$NON-NLS-1$
	public static final String JNDI_SEPARATOR_STRING = "/"; //$NON-NLS-1$

	private static BOFactory boFactory = null;

	private String icServers;
	private String locale;

	static
	{
		boFactory = (BOFactory)ServiceManager.INSTANCE.locateService("com/ibm/websphere/bo/BOFactory");
	}

	/**
	 * 
	 */
	public CwSessionBean()
	{
		icServers = null;
		mySessionCtx = null;
		locale = Locale.getDefault().toString();
	}

	/**
	 * getSessionContext
	 */
	public javax.ejb.SessionContext getSessionContext()
	{
		return mySessionCtx;
	}

	/**
	 * setSessionContext
	 */
	public void setSessionContext(javax.ejb.SessionContext ctx)
	{
		mySessionCtx = ctx;
	}

	/**
	 * ejbCreate
	 */
	public void ejbCreate() throws javax.ejb.CreateException
	{
/*		
		InitialContext initialcontext = null;
		try
		{
			initialcontext = new InitialContext();
			icServers = (String)initialcontext.lookup("java:comp/env/ICServers");
		}
		catch (NamingException namingexception)
		{
			throw new CreateException(" Error Creating Bean Instance: " + namingexception.getMessage());
		}
		if (icServers == null)
		{
			throw new CreateException("Invalid Bean Configuration, No Interchange Servers have been configured for the bean.");
		}
		setLogging(initialcontext);
		setTracing(initialcontext);
		setCwSessionConfig(initialcontext);
		if(AccessLogging.getTraceLevel() > 0)
		{
			AccessLogging.trace("EJB Create completed ");
		}
*/		
	}

	/*
	 * @param context
	 */
	private void setLogging(Context context)
	{
		String METHODNAME = "setLogging";

		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, context);
		}
		System.out.println("The Bean will use the WPS default " +
				"java.util.logging.Logger logging. Set Logging level via" +
				"WPS Server ");
/*		
		String s = null;
		try
		{
			s = (String)context.lookup("java:comp/env/logFile");
		}
		catch (NamingException namingexception)
		{
			System.out.println("Encountered naming error, while looking for the log-file configuration : " + namingexception.getMessage());
			System.out.println("The Bean will use the default java.util.logging.Logger logging ");
		}
		if (s == null)
		{
			// AccessLogging.setDefaultLogFile();
		}
		else
		{
			PrintWriter printwriter = null;
			try
			{
				printwriter = new PrintWriter(new FileOutputStream(s));
				// AccessLogging.setLogFile(printwriter);
			}
			catch (FileNotFoundException filenotfoundexception)
			{
				printwriter = new PrintWriter(System.out);
			}
		}
		s = null;
*/		

		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME);
		}
	}

	/*
	 * @param context
	 */
	private void setTracing(Context context)
	{
		String METHODNAME = "setTracing";

		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, context);
		}
		System.out.println("The Bean will use the WPS default " +
				"java.util.logging.Logger logging. Set Tracing level via" +
				"WPS Server ");
/*		
		int i = 0;
		try
		{
			i = ((Integer)context.lookup("java:comp/env/traceLevel")).intValue();
		}
		catch (NumberFormatException numberformatexception)
		{
			AccessLogging.logError("Invalid trace-level encountered for bean tracing : " + i);
		}
		catch (NamingException namingexception)
		{
			AccessLogging.logError("Encountered naming error, while reading the bean trace level: " + namingexception.getMessage());
		}
		if (i > 0)
		{
			AccessLogging.setTraceLevel(i);
			AccessLogging.trace("Trace Level for bean is set to : " + i);
		}
*/		
		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME);
		}
	}

	/*
	 * @param context
	 */
	private void setCwSessionConfig(Context context)
	{
		String METHODNAME = "setCwSessionConfig";

		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, context);
		}
		StringTokenizer stringtokenizer = new StringTokenizer(icServers, ",");
		while (stringtokenizer.hasMoreElements())
		{
			String s = stringtokenizer.nextToken();
			String s1 = null;
			String s2 = null;
			String s3 = null;
			int i = 1;
			try
			{
				s1 = (String)context.lookup("java:comp/env/" + s + "/" + "userName");
				s2 = (String)context.lookup("java:comp/env/" + s + "/" + "passWord");
				s3 = (String)context.lookup("java:comp/env/" + s + "/" + "iorLocation");
				i = ((Integer)context.lookup("java:comp/env/" + s + "/" + "numAccessSessions")).intValue();
				if (i <= 0)
				{
					i = 1;
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Configured " +
							"value for property numAccessSessions is invalid . " +
							"Using default value of 1");
				}
			}
			catch (NumberFormatException numberformatexception)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Encountered " +
						"error while accessing the configuration property " +
						"numAccessSessions Using default value of 1");
			}
			catch (NamingException namingexception)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Encountered " +
						"Naming Services error: Skipping Session creations " +
						"for server: " + s);
				continue;
			}
			if (s1 == null || s2 == null || s3 == null)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Null UserName " +
						"or PassWord or IOR File specified for Server: " + s);
				continue;
			}
			Object obj;
			try
			{
				obj = new FileInputStream(new File(s3));
			}
			catch (FileNotFoundException filenotfoundexception)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Invalid IOR " +
						"File: " + s3 + " skipping session creations for the " +
								"server : " + s);
				continue;
			}
		}
		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME);
		}
	}

	/**
	 * ejbActivate
	 */
	public void ejbActivate()
	{
	}

	/**
	 * ejbPassivate
	 */
	public void ejbPassivate()
	{
	}

	/**
	 * ejbRemove
	 */
	public void ejbRemove()
	{
		String METHODNAME = "ejbRemove";
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "EJB Remove Context called");
	}

	/**
	 * @param ICSName
	 * @param collabName
	 * @param portName
	 * @param serializedData
	 * @param mimeType
	 * @param verb
	 * @return
	 */
	public String executeCollaborationExtended(String ICSName, String collabName, String portName, String serializedData, String mimeType, String verb)
	//    throws CollaborationExecutionException
	{
		String METHODNAME = "executeCollaborationExtended";

		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, new Object[]{ICSName, 
					collabName, portName, serializedData, mimeType, verb});
		}

		// Target Service
		Service target = (Service)ServiceManager.INSTANCE.locateService("RoutingPacketPartner");

		// Get an instance of the target service input BO
		Type boType = target.getReference().getOperationType("Route").getInputType();
		DataObject request = boFactory.createByType(boType);
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "boType = target.getReference() : boType is: " + boType);
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "request = boFactory.createByType(boType) request is : " + request);

		// Populate DataObject with input data
		// sb.append(collabName).append("_").append(portName);
		StringBuffer sb = new StringBuffer(collabName);
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "StringBuffer sb with just collabName is : " + sb.toString());
		
		sb.append("_");
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "StringBuffer sb with collabName plus \"_\" is : " + sb.toString());
		
		sb.append(portName);
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "StringBuffer sb with collabName plus \"_\" plus port is : " + sb.toString());

		request.set("consumer", sb.toString());
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "StringBuffer sb Consumer is : " + sb.toString());
		
		sb.setLength(0);
		request.set("busObj", serializedData);
		request.set("mimeType", mimeType);
		request.set("verb", verb);
		
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "DataObject request consumer is : " + request.getString("consumer"));
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "DataObject request busObj is : " + request.getString("busObj"));
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "DataObject request mimeType is : " + request.getString("mimeType"));
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "DataObject request verb is : " + request.getString("verb"));
		
		// Send DataObject to target Service and get response
		DataObject resultDO = null;
		String result = null;
		try
		{
			if (logger.isLoggable(Level.FINER))
			{
				BOXMLSerializer xmls = (BOXMLSerializer) ServiceManager.INSTANCE.locateService("com/ibm/websphere/bo/BOXMLSerializer");
				xmls.writeDataObject(request, request.getType().getURI(), request.getType().getName(), System.out);
			}
			resultDO = (DataObject)target.invoke("Route", request);
			
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Result of AccessEJB call is = " + resultDO);
			// result = (String)target.invoke("Route", request);
			result = resultDO.getString("result");
		}
		catch (Exception e)
		{
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "busObj = " + "Inside catch Exception Block e is : " + e.getClass()); 
			if (logger.isLoggable(Level.FINER))
			{
				e.printStackTrace();
			}
		}
		//((Service)ServiceManager.INSTANCE.locateService("DynamicRouting")).invoke("Route",args);

		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME, result);
		}

		return result;
	}

	/**
	 * @param ICSName
	 * @param collabName
	 * @param portName
	 * @param serializedData
	 * @param mimeType
	 * @param verb
	 * @param locale
	 * @return
	 */
	public String executeCollaborationExtendedWithLocale(String ICSName, String collabName, String portName, String serializedData, String mimeType, String verb, String locale)
	//    throws CollaborationExecutionException
	{
		String METHODNAME = "executeCollaborationExtendedWithLocale";
		String result = null;
		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, new Object[]{ICSName, 
					collabName, portName, serializedData, mimeType, verb, locale});
		}
		
		result =  executeCollaborationExtended(ICSName, collabName, portName, serializedData, mimeType, locale);
		
		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME, result);
		}
		return result;
	}

}
