/**
 * BEGIN CMVC
 * *************************************************************************
 *
 *   Workfile: WBISRVR/ws/code/migration.wbi.ics.hapi/Access_EJB/DynamicRouting/com/ibm/sel/PreRoute_TargetCollab_TargetPortImpl.java, wbi.migration.ics.hapi, WBI70.WBISRVR, of1016.04
 *   Last update: 07/11/13 20:35:12
 *   SCCS path, id: /family/botp/vc/10/7/2/8/s.04 1.9
 *
 * ************************************************************************
 * END CMVC
 * BEGIN COPYRIGHT
 * ************************************************************************
 * Licensed Materials - Property of IBM
 * 5724-L01, 5655-N53, 5724-I82, 5655-R15 
 * 
 * Copyright IBM Corporation 2006, 2007. All Rights Reserved.
 * US Government Users Restricted Rights- Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 *
 * DESCRIPTION:
 *
 * Change History:
 *
 * Reason          Date        User id     Description
 * ----------------------------------------------------------------------------
 *
 * ***********************************************************************
 * END COPYRIGHT
 **/

package com.ibm.sel;

import java.util.logging.Level;
import java.util.logging.Logger;

import Collaboration.BaseCollaboration;
import Collaboration.BusObj;
import CxCommon.BusinessObject;
import CxCommon.BusinessObjectInterface;
import CxCommon.CxConstant;
import CxCommon.Exceptions.CxObjectNoSuchAttributeException;

import com.crossworlds.DataHandlers.DataHandler;
import com.ibm.websphere.bo.BOXMLSerializer;
import com.ibm.websphere.sca.Service;
import com.ibm.websphere.sca.ServiceManager;
import com.ibm.websphere.sca.Ticket;
import commonj.sdo.DataObject;

/**
 * 
 * <dt>
 *
 * </dt>
 */
public class PreRoute_TargetCollab_TargetPortImpl
{

	public static final String COPYRIGHT = "Copyright IBM Corporation 2007."; //$NON-NLS-1$
	public static final String CLASSNAME = PreRoute_TargetCollab_TargetPortImpl.class.getName();
	private static Logger logger = Logger.getLogger(CLASSNAME);

	public static final String MO_DATAHANDLER_DEFAULT = "MO_DataHandler_Default"; //$NON-NLS-1$

	/**
	 * Default constructor.
	 */
	public PreRoute_TargetCollab_TargetPortImpl()
	{
		super();
	}

	/**
	 * Return a reference to the component service instance for this
	 * implementation class. This method should be used when passing this
	 * service to a partner reference or if you want to invoke this component
	 * service asynchronously.
	 * 
	 * @generated (com.ibm.wbit.java)
	 *
	 * @return
	 */
	private Object getMyService()
	{
		return (Object)ServiceManager.INSTANCE.locateService("self");
	}

	/**
	 * This method is used to locate the service for the reference named
	 * "TestBOInterfacePartner". This will return an instance of
	 * {@link com.ibm.websphere.sca.Service}. This is the dynamic interface
	 * which is used to invoke operations on the reference service either
	 * synchronously or asynchronously. You will need to pass the operation name
	 * in order to invoke an operation on the service.
	 * 
	 * @generated (com.ibm.wbit.java)
	 * 
	 * @return Service
	 */
	public Service locateService_TestBOInterfacePartner()
	{
		String METHODNAME = "locateService_TestBOInterfacePartner";
		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME);
		}
		Service result = (Service)ServiceManager.INSTANCE.locateService("TestBOInterfacePartner");
		
		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME, result);
		}
		return result;
	}

	/**
	 * Method generated to support implemention of operation "Route" defined for WSDL port type 
	 * named "interface.RoutingPacket".
	 * 
	 * Please refer to the WSDL Definition for more information 
	 * on the type of input, output and fault(s).
	 *
	 * @param consumer
	 * @param busObj
	 * @param mimeType
	 * @param verb
	 * @return
	 */
	public String Route(String consumer, String busObj, String mimeType, String verb)
	{
		String METHODNAME = "Route";

		if (logger.isLoggable(Level.FINER))
		{
			logger.entering(CLASSNAME, METHODNAME, new Object[]{consumer, mimeType, verb});
		}
		// Get Proper DH
		logger.logp(Level.FINER, CLASSNAME, METHODNAME, "busObj = " + busObj);

		Object options = null;
		DataHandler dataHandler = null;
		String typeName = null;
		String response = null;
		String dhClassName = null;
		String boPrefix = "";
		BusinessObject modhBO = null;
		BusinessObject mtBO = null;

		try
		{
			if (mimeType != null)
			{
				dataHandler = null;

				// Requires BO MO_Default
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before BusinessObject modhBO = new BusinessObject(MO_DATAHANDLER_DEFAULT)");
				modhBO = new BusinessObject(MO_DATAHANDLER_DEFAULT);

				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After modhBO = " + modhBO);

				modhBO.setDefaultAttrValues();
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before String typeName = modhBO.getAttrType(mimeType).getTypeName();");

				typeName = modhBO.getAttrType(mimeType).getTypeName();
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After typeName = " + typeName);

				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before BusinessObject mtBO = new BusinessObject(typeName)");

				mtBO = new BusinessObject(typeName);

				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After mtBO = " + mtBO);
				mtBO.setDefaultAttrValues();

				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After mtBO.setDefaultAttrValues() = " + mtBO);

				dhClassName = (String)mtBO.getAttrValue("ClassName");
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "dhClassName = " + dhClassName);
				try
				{
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "inside of try block for boPrefix = (String) mtBO.getAttrValue(\"BOPrefix\")");

					boPrefix = (String)mtBO.getAttrValue("BOPrefix");
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "inside of try block boPrefix = " + boPrefix);

				}
				catch (CxObjectNoSuchAttributeException e1)
				{

					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "inside of catch block for boPrefix = (String) mtBO.getAttrValue(\"BOPrefix\")");
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "We know that some of these BOs do not have this attribute if BOPrefix is present we wlll use it,  if not set use default value EMPTY_STR (\"\")");
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Exception e1.errorMessage is: " + e1.errorMessage);
					// We know that some of these BOs do not have this attribute
					// -- if BOPrefix is present we wlll use it, 
					// -- if not set use default value EMPTY_STR ("")
				}
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before dataHandler = DataHandler.createHandler(dhClassName, mimeType, boPrefix");
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before createHandler dhClassName is: " + dhClassName);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before createHandler mimeType is: " + mimeType);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before createHandler boPrefix is: " + boPrefix);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "We will call the Datahandler for mimetype = " + mimeType);

				try
				{
					Class cn = Class.forName(dhClassName);
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Class cn = Class.forName(dhClassName) is " + cn);
					dataHandler = DataHandler.createHandler(dhClassName, mimeType, boPrefix);
				}
				catch (Exception e2)
				{
					logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Exception caought is: " + e2.getLocalizedMessage());
					if (logger.isLoggable(Level.FINER))
					{
						e2.printStackTrace();
					}
					throw e2;
				}
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "after  dataHandler is: " + dataHandler);
			}

			// Get BO
			BusObj request = null;

			if (dataHandler == null)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Inside if (dataHandler == null)");
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before BusObj request = (BusObj)BaseCollaboration.deserialize(busObj)");
				request = (BusObj)BaseCollaboration.deserialize(busObj);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After request = " + request);
			}
			else
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Inside else We are just before BusinessObjectInterface tmpReq =  dataHandler.getBO(busObj, mtBO)");

				BusinessObjectInterface tmpReq = dataHandler.getBO(busObj, mtBO);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After tmpReq = " + tmpReq);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After BusinessObjectInterface tmpReq =  dataHandler.getBO(busObj, mtBO)");

				request = new BusObj((BusinessObject)tmpReq);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After request = " + request);
			}
			
			// Set verb
			if (request.getVerb() == CxConstant.EMPTY_STRING)
			{
				request.setVerb(verb);
			}
			// Send BO to Partner
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before DataObject result = (DataObject)this.locateService_CustomerBG_PortTypePartner().invoke(\"Sync\", request.getBusinessGraph())");

			DataObject tmpres = request.getBusinessGraph();
			if (logger.isLoggable(Level.FINER))
			{
				BOXMLSerializer xmls = (BOXMLSerializer) ServiceManager.INSTANCE.locateService("com/ibm/websphere/bo/BOXMLSerializer");
				xmls.writeDataObject(tmpres, tmpres.getType().getURI(), tmpres.getType().getName(), System.out);
			}
			
			DataObject result = (DataObject)this.locateService_TestBOInterfacePartner().invoke("Sync", tmpres);
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After result = " + result);

			// Convert DataObject result to string
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before BusObj resultBO = new BusObj(result)");
			
			BusObj resultBO = new BusObj(result);
			//  BusObj resultBO = request;
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After resultBO = " + resultBO);
			
			if (dataHandler == null)
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Inside if (dataHandler == null) ");
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Before String response = BaseCollaboration.serialize(resultBO)");

				response = BaseCollaboration.serialize(resultBO);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After response = " + response);
			}
			else
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Inside else Before String response = dataHandler.getStringFromBO(resultBO.getContent(), mtBO)");

				BusinessObject tmpBO = resultBO.getContent(); 
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "tmpBO = resultBO.getContent() is: " + tmpBO);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "mtBO is: " + mtBO);
				
				response = dataHandler.getStringFromBO(tmpBO, mtBO);
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "After response = " + response);
			}
		}
		catch (Exception e3)
		{
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Inside " + CLASSNAME +"."+ METHODNAME + "catch Exception Block e is : " + e3.getClass());
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Caught Exception , " + e3.getCause());
			logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Caught Exception , " + e3.getLocalizedMessage());
			if (logger.isLoggable(Level.FINER))
			{
				logger.logp(Level.FINER, CLASSNAME, METHODNAME, "Caught Exception e3. e3.printStackTrace is, \n");
				e3.printStackTrace();
			}
		}

		if (logger.isLoggable(Level.FINER))
		{
			logger.exiting(CLASSNAME, METHODNAME, response);
		}
		return response;
	}

	/**
	 * Method generated to support the async implementation using callback for
	 * the operation "interface.TestBOInterface#operation1(DataObject request)"
	 * of wsdl interface "interface.TestBOInterface"
	 */
	public void onOperation1Response(Ticket __ticket, DataObject returnValue, Exception exception)
	{
		throw new IllegalStateException("Async Callback not supported");
	}

}// end class