--BEGIN CMVC
--*************************************************************************
--
--  Workfile: WBISRVR/ws/code/scheduler.wbi/src/dbscripts/CommonDB/SQLServer/createTable_AppScheduler.sql, wbi.scheduler, WBI70.WBISRVR, of1016.04
--  Last update: 07/03/16 03:24:40
--  SCCS path, id: /family/botp/vc/10/9/8/9/s.77 1.2
--
--*************************************************************************
--END CMVC
--BEGIN COPYRIGHT
--*************************************************************************
--
--  Licensed Materials - Property of IBM
--  5724-L01, 5655-N53, 5724-I82, 5655-R15
--  (C) Copyright IBM Corporation 2004, 2006, 2007.
--  All rights reserved. US Government Users Restricted Rights - Use,
--  duplication, or disclosure restricted by GSA ADP Schedule Contract with
--  IBM Corp.
--
--*************************************************************************
--END COPYRIGHT
--
-- create the schema

CREATE TABLE WSCH_TASK
(
  TASKID             BIGINT                NOT NULL ,
  VERSION            VARCHAR(5)            NOT NULL ,
  ROW_VERSION        INT                   NOT NULL ,
  TASKTYPE           INT                   NOT NULL ,
  TASKSUSPENDED      TINYINT               NOT NULL ,
  CANCELLED          TINYINT               NOT NULL ,
  NEXTFIRETIME       BIGINT                NOT NULL ,
  STARTBYINTERVAL    VARCHAR(254)              NULL ,
  STARTBYTIME        BIGINT                    NULL ,
  VALIDFROMTIME      BIGINT                    NULL ,
  VALIDTOTIME        BIGINT                    NULL ,
  REPEATINTERVAL     VARCHAR(254)              NULL ,
  MAXREPEATS         INT                   NOT NULL ,
  REPEATSLEFT        INT                   NOT NULL ,
  TASKINFO           IMAGE                     NULL ,
  NAME               VARCHAR(254)          NOT NULL ,
  AUTOPURGE          INT                   NOT NULL ,
  FAILUREACTION      INT                       NULL ,
  MAXATTEMPTS        INT                       NULL ,
  QOS                INT                       NULL ,
  PARTITIONID        INT                       NULL ,
  OWNERTOKEN         VARCHAR(200)          NOT NULL ,
  CREATETIME         BIGINT                NOT NULL
) ;

ALTER TABLE WSCH_TASK WITH NOCHECK ADD CONSTRAINT WSCH_TASK_PK PRIMARY KEY NONCLUSTERED ( TASKID );

CREATE INDEX WSCH_TASK_IDX1 ON WSCH_TASK
(
  TASKID, OWNERTOKEN
) ;

CREATE CLUSTERED INDEX WSCH_TASK_IDX2 ON WSCH_TASK
(
  NEXTFIRETIME ASC ,
  REPEATSLEFT ,
  PARTITIONID
) ;

CREATE TABLE WSCH_TREG
(
  REGKEY             VARCHAR(254)          NOT NULL ,
  REGVALUE           VARCHAR(254)              NULL ,
  PRIMARY KEY ( REGKEY )
) ;

CREATE TABLE WSCH_LMGR
(
  LEASENAME          VARCHAR(254)          NOT NULL ,
  LEASEOWNER         VARCHAR(254)          NOT NULL ,
  LEASE_EXPIRE_TIME  BIGINT                         ,
  DISABLED           VARCHAR(5)
) ;

ALTER TABLE WSCH_LMGR WITH NOCHECK ADD CONSTRAINT WSCH_LMGR_PK PRIMARY KEY  NONCLUSTERED ( LEASENAME ) ;

CREATE TABLE WSCH_LMPR
(
  LEASENAME          VARCHAR(254)          NOT NULL ,
  NAME               VARCHAR(254)          NOT NULL ,
  VALUE              VARCHAR(254)          NOT NULL
) ;

CREATE INDEX WSCH_LMPR_IDX1 ON WSCH_LMPR
(
  LEASENAME, NAME
) ;
