# *
# * BEGIN CMVC
# * *************************************************************************
# *
# *   Workfile: WBISRVR/ws/code/scheduler.wbi/src/util/AppScheduler/AppSchedulerUpdate.py, wbi.scheduler, WBI70.WBISRVR, of1016.04
# *   Last update: 09/08/20 04:02:42
# *   SCCS path, id: /family/botp/vc/11/9/0/1/s.62 1.4 /family/botp/vc/11/9/0/1/s.62
# *
# * ************************************************************************
# * END CMVC
# * BEGIN COPYRIGHT
# *************************************************************************
# *
# * Licensed Materials - Property of IBM
# * 5724-L01, 5655-N53, 5724-I82, 5655-R15
# * (C) Copyright IBM Corporation 2007,2009.
# * All rights reserved. US Government Users Restricted Rights - Use,
# * duplication, or disclosure restricted by GSA ADP Schedule Contract with
# * IBM Corp.
# *
# *************************************************************************
# *
# * DESCRIPTION:
# *
# * Change History:
# *
# * Reason          Date        User id     Description
# * ----------------------------------------------------------------------------
# *
# * ***********************************************************************
# * END COPYRIGHT
# *
# *
#*******************************************************************************************************
#
# This script will be invoked automatically by WBIPostUpgrade during WPS AppScheduler migration.
#
#*******************************************************************************************************
import sys
False = 0
True = 1

#--------------------------------------------------------------------------
# get the directory where WAS is installed
#--------------------------------------------------------------------------
def getWASHome():
	return getPropertyValue('was.install.root')

#------------------------------------------------------------------------------
# get the property value by the the property name; If property not available, return ''
#------------------------------------------------------------------------------
def getPropertyValue(propertyName):
	propertyValue = java.lang.System.getProperty(propertyName)
	print "inside getPropertyValue propertyName is: " + str(propertyName)
	print "propertyValue is : " + str(propertyValue)
	
	if(propertyValue == None):
		return ''
	return propertyValue

#------------------------------------------------------------------------------
# a utility method
#------------------------------------------------------------------------------
def wsadminToList(inStr):
	outList=[]
	if (len(inStr)>0 and inStr[0]=='[' and inStr[-1]==']'):
		inStr = inStr[1:-1]
		tmpList = inStr.split(" ")
	else:
		tmpList = inStr.split("\n")  #splits for Windows or Linux
	for item in tmpList:
		item = item.rstrip();        #removes any Windows "\r"
		if (len(item)>0):
			outList.append(item)
	return outList
#endDef

#------------------------------------------------------------------------------
# check whether the specified application is installed on specified cell
#------------------------------------------------------------------------------
def checkIfApplicationInstalled(applicationName):
	isAppInstalled = False
	print "inside checkIfApplicationInstalled applicationName is: " + str(applicationName)
	applications = AdminApp.list().splitlines()
	for application in applications:
		print "inside forLoop application is : " + str(application)
		if (application == applicationName):
			isAppInstalled = True
			return isAppInstalled
	return isAppInstalled

#------------------------------------------------------------------------------
# uninstall the application with the specified parameter
#------------------------------------------------------------------------------
def uninstallApplication(applicationName, node, server):
	result = False
	print "inside uninstallApplication applicationName is: " + str(applicationName)
	undeployOptions = ' -node ' + node + ' -server ' + server
	try:
		AdminApp.uninstall(applicationName,undeployOptions)
	except:
		print "Error happened when trying to uninstall the application: " + str(applicationName)
		result = True
	AdminConfig.save()
	return result

#------------------------------------------------------------------------------
# install the application with the specified parameter
#------------------------------------------------------------------------------
def installApplication(applicationName, earLocation, cell, node, nodeType, server):
	result = False
	print "inside installApplication, applicationName is: " + str(applicationName)
	print "earLocation is: " + str(earLocation)
	print "cell is: " + str(cell) + " node is: " + str(node) + " nodeType is: " + str(nodeType) + " server is: " + str(server)
	
	isAppInstalled = checkIfApplicationInstalled(applicationName)
	print 'isAppInstalled is 0=False, 1=True: ' + str(isAppInstalled)
	
	#1.IF: the application was not installed yet, install the application 
	if(isAppInstalled == False):
		print "1.IF: the application was not installed yet, install the application"
		print "in if (isAppInstalled == False)"
		
		deployOptions = '-appname ' + applicationName + ' -cell ' +  cell + ' -node ' + node + ' -server ' + server
		print "deployOptions are: " + str(deployOptions)
		try:
			AdminApp.install(earLocation, deployOptions)
		except:
			print "exception happened when trying to install application " + str(applicationName)
			result = True
		else:
			AdminConfig.save()
			
	#2.Else: the application was installed, update the existing application on the server
	# Need to change this so the application and the mapping are updated
	else:
		print "in else 2.1 update the existing server"
		try:
			deployOptions = '-operation update  -contents ' + earLocation + ' -contenturi AppScheduler.ear'
			print "deployOptions are: " + str(deployOptions)
			AdminApp.update(applicationName, 'app', deployOptions)
			
		except:
			print "exception happened when trying to install application " + str(applicationName)
			return True
		else:
			AdminConfig.save()
			
	#3. Need to update the mapping of the server to the Application
	print "3. Need to check the existing mapping of the Application to the server and update if not present"
	newTarget = 'WebSphere:cell=' + cell + ',node=' + node + ',server=' + server
	
	print "3 Get the old target information"
	moduleList = AdminApp.listModules(applicationName, '-server')
	infoList = moduleList.split('#')
	module = infoList[0]
	# AdminApp.listModules returns AppScheduler for the module name but the 
	# name that -MapModulesToServers wants is AppSchedulerEJB
	moduleName = module + 'EJB'
	uri = infoList[1].replace('+',',')
	oldTarget = infoList[2]
	
	print "3 check whether the target already exist in the target mapping"
	result = checkTargetExist(oldTarget,newTarget)
	
	# Need to update the mapping of the server to the Application
	if(result == True):
		print "3.1 installApplication The application :" + str(applicationName) + " is already mapped to " + str(newTarget)
		
	else:
		if(nodeType != 'dmgr'):
			print "3.2 Otherwise, add the target mapping to the server"
			try:
				detailOption = [[moduleName,uri,oldTarget + '+' + newTarget]]
				options = ['-MapModulesToServers',detailOption]
				AdminApp.edit(applicationName, options)
			except:
				print "exception generated while attempting application to server target mapping"
			else:
				AdminConfig.save()
		else:
			print "NodeType is " + str(nodeType) + " do not attempt to map application to this server"
			
	return result;

#------------------------------------------------------------------------------
# install the application with the specified parameter
#------------------------------------------------------------------------------
def installApplicationCluster(applicationName, earLocation, cell, cluster):
	result = False
	print "inside installApplicationCluster applicationName is: " + str(applicationName)
	print "earLocation is: " + str(earLocation)
	print "cell is: " + str(cell) + " node is: " + str(node) + " cluster is: " + str(cluster)
	
	isAppInstalled = checkIfApplicationInstalled(applicationName)
	print 'isAppInstalled is 0=False, 1=True: ' + str(isAppInstalled)
	
	print "1.IF: the application was not installed yet, install the application"
	
	#1.IF: the application was not installed yet, install the application 
	if(isAppInstalled == False):
		print "1.IF: the application was not installed yet, install the application"
		print "in if (isAppInstalled == False)"
		
		deployOptions = '-appname ' + applicationName + ' -cell ' +  cell + ' -cluster ' + cluster
		print "deployOptions are: " + str(deployOptions)
		try:
			AdminApp.install(earLocation, deployOptions)
		except:
			print "exception happened when trying to install application " + str(applicationName)
			return True
		else:
			AdminConfig.save()
			
	# 2 Need to update the mapping of the cluster to the Application
	else:
		print "2.Else: the application was installed, add the mapping if available"
		print "in else 2.1 Construct the new cluster target"
		newTarget = 'WebSphere:cell=' + cell + ',cluster=' + cluster
		
		print "2.2 Get the old target information"
		moduleList = AdminApp.listModules(applicationName, '-server')
		infoList = moduleList.split('#')
		module = infoList[0]
		# AdminApp.listModules returns AppScheduler for the module name but the 
		# name that -MapModulesToServers wants is AppSchedulerEJB
		moduleName = module + 'EJB'
		uri = infoList[1].replace('+',',')
		oldTarget = infoList[2]
		
		print "2.3 check whether the target already exist in the target mapping"
		result = checkTargetExist(oldTarget,newTarget)
		
		# Need to update the mapping of the cluster to the Application
		if(result == True):
			print "2.3.1 installApplicationCluster The application :" + str(applicationName) + "is already mapped to " + str(newTarget)
			
		else:
			if(nodeType != 'dmgr'):
				print "2.3.2 Otherwise, add the target mapping to the server"
				print "in else 2.3.2"
				try:
					detailOption = [[moduleName,uri,oldTarget + '+' + newTarget]]
					options = ['-MapModulesToServers',detailOption]
					AdminApp.edit(applicationName, options)
				except:
					print "exception generated while attempting application to cluster target mapping"
				else:
					AdminConfig.save()
			else:
				print "NodeType is " + str(nodeType) + " do not attempt to map application to this server"
				
	return result;
#------------------------------------------------------------------------------
# check whether the newTarget already exists in oldTarget;If true,return 0; otherwise, return 1
#------------------------------------------------------------------------------
def checkTargetExist(oldTarget,newTarget):
	print "inside checkTargetExist"
	print "oldTarget is: " + str(oldTarget)
	print "newTarget is: " + str(newTarget)
	
	result = False
	targetList = oldTarget.split('+')
	for target in targetList:
		if(target == newTarget):
			result = True
			
	print "result is 0=false, 1=true: " + str(result)
	return result

#------------------------------------------------------------------------------
# get the current cell
#------------------------------------------------------------------------------
def getCell():
	cellName = ''
	cellList = wsadminToList(AdminConfig.list('Cell'))
	for cell in cellList:
		cellName = AdminConfig.showAttribute(cell,'name')
		print "inside \"for cell in cellList\" cellName is: " + str(cellName)
	return cellName

#------------------------------------------------------------------------------
# get the nodes defined in specified cell
#------------------------------------------------------------------------------
def getNodeList(cell):
	nodeNameList = []
	cellId = AdminConfig.getid('/Cell:' + cell)
	if(cellId == ''):
		return nodeNameList
	nodeList = wsadminToList(AdminConfig.list('Node',cellId))
	for node in nodeList:
		nodeName = AdminConfig.showAttribute(node,'name')
		nodeNameList.append(nodeName)
		print "inside \"for node in nodeList\" nodeName is: " + str(nodeName)
	return nodeNameList

#------------------------------------------------------------------------------
# get the servers defined in specified cell and node; need to filter out the node agent, cluster member
#------------------------------------------------------------------------------
def getServerList(cell,node):
	print "inside getServerList " + str(cell) + " " + str(node)
	serverNameList = []
	nodeId = AdminConfig.getid('/Cell:' + cell + '/Node:' + node)
	print "nodeId is: " + str(nodeId)
	if(nodeId == ''):
		return serverNameList
	serverList = wsadminToList(AdminConfig.list('Server',nodeId))
	for server in serverList:
		serverName = AdminConfig.showAttribute(server,'name')
		clusterName = AdminConfig.showAttribute(server,'clusterName')
		print "inside \"for server in serverList\" serverName is: " + str(serverName)
		print "inside \"for server in serverList\" clusterName is: " + str(clusterName)
		if(clusterName == None):
			if(serverName != 'nodeagent'):
				serverNameList.append(serverName)
	return serverNameList

#------------------------------------------------------------------------------
# get the location of installable RemoteAL application
#------------------------------------------------------------------------------
def getRemoteAppLocation(cell,node):
	return getWASHome() + '/AppScheduler/lib/WBIScheduler.ear'

#------------------------------------------------------------------------------
# check whether the update is required for current node;
# If true return 1, false return 0
#
# 1. If the nodeVersion is 6.0.1.x then update is required
#
# 2. If the node is dmgr node, then need to get the servers, update each server
#    and then update the Application server targets
#
# 3. If the nodeVersion is 6.0.2.x then nothing to do
#------------------------------------------------------------------------------
def checkIfUpdateIsRequired():
	print "inside checkIfUpdateIsRequired"
	result = False
	nodeType = getPropertyValue('wbi.upgrade.node.type')
	nodeVersion = getPropertyValue('wbi.upgrade.previous.version')
	updatedCluster = getUpdatedCluster()
	
	print "nodeType is: " + str(nodeType)
	print "nodeVersion is: " + str(nodeVersion)
	nodeVer = nodeVersion[0:5]
	print "nodeVer is: " + nodeVer
	print "updatedCluster is: " + str(updatedCluster)
	
	if (nodeVer == "6.0.1"):
		# This means any 6.0.1.x will be upgraded
		result = True
	else :
		# This means 6.0.2.x does not need upgrading
		result = False
		
#	if(updatedCluster != ''):
#		result = True
#	elif (nodeType == 'managed') or (nodeType == 'unmanaged'):
#		if(nodeVersion != ''):
#			result = True
			
	return result

#------------------------------------------------------------------------------
# get the current node name which is migrated
#------------------------------------------------------------------------------
def getUpdatedNode():
	return getPropertyValue('local.node')

#------------------------------------------------------------------------------
# get the current cluster name which is migrated, if not available return ''
#------------------------------------------------------------------------------
def getUpdatedCluster():
	return getPropertyValue('wbi.upgrade.cluster.name')

#------------------------------------------------------------------------------
# Main entry point
# 1. Read the properties to decide whether AppScheduler application needs to be updated
#
#------------------------------------------------------------------------------

# 1. check whether the update procedure should be invoked
print "start of AppSchedulerUpdate.py script Main"
updateIsRequired = checkIfUpdateIsRequired();

# 2. If update required, perform update
if (updateIsRequired):

	#2.1 Initialization
	applicationName = 'AppScheduler'
	cell = getCell()
	node = getUpdatedNode()
	cluster = getUpdatedCluster()
	nodeType = getPropertyValue('wbi.upgrade.node.type')
	
	installEarFileFrom = getRemoteAppLocation(cell,node)
	
	print "cell: CellName from getCell is: " + str(cell)
	print "node: NodeName from getUpdatedNode is: " + str(node)
	print "cluster: ClusterName from getUpdatedCluster is: " + str(cluster)
	print "nodeType: nodeType is: " + str(nodeType)
	print "installEarFileFrom: AppLocation from getRemoteAppLocation is: " + str(installEarFileFrom)
	
	#2.2 If node update is performed
	if(cluster == ''):
		serverList = getServerList(cell,node)
		# Need to add check for WEBServers need something like this from bpeLib
		for server in serverList:
			installApplication(applicationName,installEarFileFrom,cell,node,nodeType,server)
			
	#2.3 If cluster update is performed
	else:
		installApplicationCluster(applicationName,installEarFileFrom,cell,cluster)
		
# 3. Otherwise update not required, do nothing
else:
	print "Nothing needs to be done for wbi.scheduler component already at 6.0.2.x  - 6.2.x level"

